<script setup>
// This starter template is using Vue 3 <script setup> SFCs
// Check out https://vuejs.org/api/sfc-script-setup.html#script-setup
// import Placeholder from "./components/PlaceHolder/PlaceHolder.vue";

import Map from "./components/Map.vue";
import { ref } from "vue";
import projects from "./assets/data.json";
import { point, polygon, booleanWithin } from "@turf/turf";

const currentLocation = ref(undefined);
const currentProject = ref(undefined);
const currentProjectVotes = ref(undefined);
const token = ref(undefined);
const uuid = self.crypto.randomUUID();

console.log("UUID: ", uuid);

function updateLocation(data) {
  currentLocation.value = data.coords;

  const pt = point([
    +currentLocation.value.longitude,
    +currentLocation.value.latitude,
  ]);
  const firstMatch = projects.features.findIndex((element) => {
    const ply = polygon(element.geometry.coordinates);
    return booleanWithin(pt, ply);
  });

  if (firstMatch != -1) {
    console.log(`Found a match at index ${firstMatch}`);
    currentProject.value = projects.features[firstMatch].properties;
    fetchProjectData();
  }
}

function fetchProjectData() {
  fetch(
    `/api/proxy?projectAddress=${currentProject.value.projectContractAddress}&action=getProjectVotes`,
    {
      mode: "no-cors",
    }
  )
    .then((response) => {
      if (!response.ok) {
        console.log("the proxy is not reachable!!!");
      }
      return response.json();
    })
    .then((response) => {
      console.log(response);
      if (response.status === "success") {
        currentProjectVotes.value = response.result.projectVotes;
      }
    });
}

function mintToken(data) {
  console.log("Minting...", data);
  fetch(
    `/api/proxy?lat=${currentLocation.value.latitude}&lng=${currentLocation.value.longitude}&projectNr=${data.projectId}&voteOption=${data.voteOption}&uuid=${uuid}&action=triggerContract`,
    {
      mode: "no-cors",
    }
  )
    .then((response) => {
      if (!response.ok) {
        console.log("the proxy is not reachable!!!");
      }
      return response.json();
    })
    .then((response) => {
      console.log(response);
      if (response.status === "minted token") {
        token.value = response.result.token;
        fetchProjectData();
      }
    });
}
</script>

<template>
  <div class="relative bg-gray-1000 mx-auto w-full h-full px-0 py-0">
    <div class="">
      <div class="h-full px-0 py-0 w-full">
        <Map @location-changed="updateLocation" />
      </div>
      <RouterView
        :current-location="currentLocation"
        :current-project="currentProject"
        :current-project-votes="currentProjectVotes"
        :token="token"
        @mint-token="mintToken"
      >
      </RouterView>
    </div>
  </div>
</template>

<style></style>
